datablock TSShapeConstructor(CamaroDts)
{
	baseShape  = "./camaro.dts";
	sequence0  = "./root.dsq root";
	sequence1  = "./ldopen.dsq ldopen";
	sequence2  = "./ldclose.dsq ldclose";
	sequence3  = "./rdopen.dsq rdopen";
	sequence4  = "./rdclose.dsq rdclose";
	sequence5  = "./bootopen.dsq bootOpen";
	sequence6  = "./bootclose.dsq bootClose";
	sequence7  = "./bonnetopen.dsq bonnetOpen";
	sequence8  = "./bonnetclose.dsq bonnetClose";
	sequence9  = "./pitch_up.dsq pitchup";
};  

datablock WheeledVehicleData(CamaroVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./camaro.dts"; 
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 5;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";
   mountThread[4] = "sit";


	maxDamage = 300.00;
	destroyedLevel = 300.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0.2 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 10;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	 = CamaroWheelTire;
	defaultSpring = CamaroSpring;
	flatTire	    = jeepFlatTire;
	flatSpring	 = jeepFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 15000; //4000;       // Engine power
	engineBrake = 5000;         // Braking when throttle is 0
	brakeTorque = 15000;        // When brakes are applied
	maxWheelSpeed = 44;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 2000;
	rotationalDrag		= 0.2;
	
	// Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;
	
	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Scorpius";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = vehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = vehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = CamaroExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = CamaroFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   isInteractive = true;
   iNumZones = 4;

   iZone[0] = "-2.5 -1.2 0.2 -1.8 1.0 1.5";
   iZoneScript[0] = "onLeftDoor";

   iZone[1] = "1.8 -1.2 0.2 2.5 1.0 1.5";
   iZoneScript[1] = "onRightDoor";

   iZone[2] = "-1.3 -4.5 0.5 1.3 -3.3 1.1";
   iZoneScript[2] = "onBoot";

   iZone[3] = "-1.4 1.8 0.5 1.4 4.5 1.5";
   iZoneScript[3] = "onBonnet";
};

function CamaroVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.leftDoorTime) > 1300)
        {
                %obj.leftDoorTime = %time;
                %obj.leftDoor = !%obj.leftDoor;
                %obj.playThread(0, %obj.leftDoor ? ldOpen : ldClose);
        }

        return 1;
}

function CamaroVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.rightDoorTime) > 1300)
        {
                %obj.rightDoorTime = %time;
                %obj.rightDoor = !%obj.rightDoor;
                %obj.playThread(1, %obj.rightDoor ? rdOpen : rdClose);
        }

        return 1;
}

function CamaroVehicle::onBoot(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.bootTime) > 1300)
        {
                %obj.bootTime = %time;
                %obj.boot = !%obj.boot;
                %obj.playThread(2, %obj.boot ? bootOpen : bootClose);
        }

        return 1;
}

function CamaroVehicle::onBonnet(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.bonnetTime) > 1300)
        {
                %obj.bonnetTime = %time;
                %obj.bonnet = !%obj.bonnet;
                %obj.playThread(3, %obj.bonnet ? bonnetOpen : bonnetClose);
        }

        return 1;
}




function CamaroVehicle::onAdd(%db,%this)
{
%chance1 = getRandom(0,1);	//get a random integer from 0 to 1
%chance2 = getRandom(0,1);
%chance3 = getRandom(0,3);

switch(%chance2)			
{
case 0:				//we set the plain body style
%this.hideNode(body_stripeBlank);
%this.hideNode(body_stripeWhite);
%this.hideNode(body_stripeBlack);

%this.hideNode(boot_stripeBlank);
%this.hideNode(boot_stripeWhite);
%this.hideNode(boot_stripeBlack);

%this.hideNode(bonnet_stripeBlank);
%this.hideNode(bonnet_stripeWhite);
%this.hideNode(bonnet_stripeBlack);

%this.hideNode(body_ringsWhite);
%this.hideNode(body_ringsBlank);

case 1:				//we set the "stripes" body style				
%this.hideNode(body_plain);	
%this.hideNode(boot_plain);
%this.hideNode(bonnet_plain);		
%this.hideNode(body_ringsWhite);
%this.hideNode(body_ringsBlank);
}
 switch(%chance1)			//the "stripes" type has two colours for the stripes, so we have to 
	{				//settle on only one

		case 0:
		  %this.hideNode(body_stripeWhite);			//black stripes
		  %this.hideNode(boot_stripeWhite);
	          %this.hideNode(bonnet_stripeWhite);


		case 1:	
		  %this.hideNode(body_stripeBlack);			//white stripes
		  %this.hideNode(boot_stripeBlack);
		  %this.hideNode(bonnet_stripeBlack);

	}


switch(%chance3)
{
case 0:				//no roof
%this.hideNode(roofBlank);
%this.hideNode(roofWhite);
%this.hideNode(roofBlack);


case 1:				//black roof
%this.hideNode(roofBlank);
%this.hideNode(roofWhite);


case 2:				//white roof
%this.hideNode(roofBlank);
%this.hideNode(roofBlack);


case 3:				//recolourable roof
%this.hideNode(roofWhite);
%this.hideNode(roofBlack);

}

%this.hideNode(engineVent);

 parent::onAdd(%db,%this);			//apply changes (?)

}